#include "laexcp.h"

LaException::LaException()
    : std::runtime_error("LaException in LAPACK++") 
{
}

LaException::LaException(const char *where, const char *what)
    : std::runtime_error ( std::string(where ? where : "") 
			   + std::string(what ? what : "") )
{
    if (_print)
	std::cerr << "LaException: " << std::string(where ? where : "") 
		  << " : " << std::string(what ? what : "") << std::endl;
}

bool LaException::_print = false;
void LaException::enablePrint(bool e)
{
    _print = e;
}
